package jp.groupsession.v2.dba.core;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import jp.co.sjts.util.StringUtil;
import jp.groupsession.v2.dba.meta.Column;
import jp.groupsession.v2.dba.meta.Table;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * <br>[@  \] e[u̗񂩂JavaBean쐬NX
 * <br>[  ]
 * <br>[  l]
 * @author JTS
 */
public class BeanGenerator {
    /** Logging CX^X */
    private static Log log__ = LogFactory.getLog(BeanGenerator.class);

    /** e[uIuWFNg */
    private Table table__ = null;
    /** pbP[W */
    private String packageName__ = null;

    /** NXe[u + Model ł̂܂܎gptO true:̂܂܎gp, false:ϊ */
    private boolean classNameFlg__ = false;

    /**
     * <p>ftHgRXgN^
     */
    public BeanGenerator() {
    }

    /**
     * <p>e[uZbg܂
     * @param table e[u
     */
    public BeanGenerator(Table table) {
        table__ = table;
    }

    /**
     * <p>e[u擾܂B
     * @return e[u
     */
    public Table getTable() {
        return table__;
    }

    /**
     * <p>e[uZbg܂B
     * @param table e[u
     */
    public void setTable(Table table) {
        table__ = table;
    }
    /**
     * @return packageName ߂܂B
     */
    public String getPackageName() {
        return packageName__;
    }
    /**
     * @param packageName packageName ݒB
     */
    public void setPackageName(String packageName) {
        packageName__ = packageName;
    }
    /**
     * <p>BEANJava\[X𐶐܂B
     * @return Java\[X
     */
    public String generate() {
        log__.debug("generate start");
        //
        ArrayList<String> source = new ArrayList<String>();

        //pbP[W𐶐
        __createPackage(source);

        //imports𐶐
        __createImport(source);

        //NX̍s𐶐
        __createClassName(source);

        //tB[hs𐶐
        __createField(source);

        //RXgN^̐
        __createConstructor(source);

        //Getter,Setter̐
        __createGetSeter(source);

        //toCsvString
        __createCsvString(source);

        //tb^[ }̂ݐ
        source.add("}");
        log__.debug("generate end");
        return StringUtil.toStringByList(source);
    }

    /**
     * <p>pbP[W錾𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createPackage(ArrayList<String> source) {
        String pkg = null;
        pkg = getPackageName();
        String line = null;
        if (pkg == null) {
            pkg = TypeMappingResourceBundle.getString("package");
            line = "package " + pkg + ";";
        } else if (pkg.trim().length() <= 0) {
            line = "";
        } else {
            line = "package " + pkg + ";";
        }

        //pbP[W錾
        source.add(line);
        //s
        source.add("");
        return source;
    }

    /**
     * <p>import錾𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createImport(ArrayList<String> source) {

        HashMap<String, String> hm = new HashMap<String, String>();
        ArrayList cols = table__.getColumns();
        Iterator it = cols.iterator();
        while (it.hasNext()) {
            Column col = (Column) it.next();
            int type = col.getType();
            String typeFqdn = GenUtil.getTypeNameJdbcFQDN(type);
            if (!StringUtil.isNullZeroString(typeFqdn)) {
                hm.put(typeFqdn, "");
            }
        }

        //
        Set kset = hm.keySet();
        Iterator it2 = kset.iterator();
        while (it2.hasNext()) {
            String imtgt = (String) it2.next();
            if (imtgt.endsWith("long")) {
                //long̓C|[głȂ̂ŏO
            } else if (imtgt.endsWith("int")) {
                //int̓C|[głȂ̂ŏO
            } else if (imtgt.endsWith("double")) {
                //double̓C|[głȂ̂ŏO
            } else {
                source.add("import " + imtgt + ";");
            }
        }

        //VACY͕K{
        source.add("import " + TypeMappingResourceBundle.getString("NullDefault") + ";");
        source.add("import java.io.Serializable;");
        source.add("");
        return source;
    }

    /**
     * fNXԂ
     * @param tableName e[u
     * @return fNX
     */
    private String __createModelClassName(String tableName) {
        if (classNameFlg__) {
            return tableName + "Model";
        } else {
            return GenUtil.createClassName(tableName, false,
                    TypeMappingResourceBundle.getString("table_prefix"));
        }
    }

    /**
     * <p>NX錾𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createClassName(ArrayList<String> source) {
        String tblName = table__.getName();
        String clsName = __createModelClassName(tblName);

        //
        String line = "public class " + clsName + " implements Serializable {";

        //NX錾
        source.add("/**");
        source.add(" * <p>" + tblName + " Data Bindding JavaBean");
        source.add(" *");
        source.add(" * @author " + GenConst.PRODUCT_NAME + " version " + GenConst.VERSION);
        source.add(" */");
        source.add(line);
        //s
        source.add("");
        return source;
    }

    /**
     * <p>tB[hs𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createField(ArrayList<String> source) {
        ArrayList cols = table__.getColumns();
        Iterator it = cols.iterator();
        while (it.hasNext()) {

            Column col = (Column) it.next();

            String colName = col.getName();

            //tB[h
            String fldName = GenUtil.createFieldName(colName);

            //^
            int type = col.getType();
            String typeStr = GenUtil.getTypeNameJdbc(type);

            //JavaDocRg
            source.add(GenConst.INDENT + "/** " + colName + " mapping */");
            //tB[h錾
            String line = GenConst.INDENT + "private " + typeStr + " " + fldName + ";";
            source.add(line);
        }

        //s
        source.add("");
        return source;
    }

//    /**
//     *
//     * @return JDBCɑΉJavãf[^^
//     */
//    private String __getTypeStr(Column col) {
//        String ret = null;
//        int type = col.getType();
//        int size = col.getSize();
//
//        switch (type) {
//            case Types.ARRAY :
//                log__.debug("ARRAY");
//            case Types.BIGINT :
//                log__.debug("BIGINT");
//            case Types.BINARY :
//                log__.debug("BINARY");
//            case Types.BIT :
//                log__.debug("BIT");
//            case Types.BLOB :
//                log__.debug("BLOB");
//            case Types.BOOLEAN :
//                log__.debug("BOOLEAN");
//            case Types.CHAR :
//                log__.debug("CHAR");
//            case Types.CLOB :
//                log__.debug("CLOB");
//            case Types.DATALINK :
//                log__.debug("DATALINK");
//            case Types.DATE :
//                ret = "Date";
//                log__.debug("DATE");
//                break;
//
//            case Types.DECIMAL :
//                log__.debug(Types.DECIMAL + "DECIMAL");
//            case Types.DISTINCT :
//                log__.debug(Types.DISTINCT + " DISTINCT");
//            case Types.DOUBLE :
//                log__.debug(Types.DOUBLE + " DOUBLE");
//            case Types.FLOAT :
//                log__.debug(Types.FLOAT + " FLOAT");
//            case Types.INTEGER : //3
//                log__.debug(Types.INTEGER + " INTEGER");
//                ret = "NUMBER(" + col.getSize() + "," + col.getDigits() + ")";
//                break;
//
//            case Types.JAVA_OBJECT :
//                log__.debug("JAVA_OBJECT");
//            case Types.LONGVARBINARY :
//                log__.debug("LONGVARBINARY");
//            case Types.LONGVARCHAR :
//                log__.debug("LONGVARCHAR");
//            case Types.NULL :
//                log__.debug("NULL");
//            case Types.NUMERIC :
//                log__.debug("NUMERIC");
//            case Types.OTHER :
//                log__.debug("OTHER");
//            case Types.REAL :
//                log__.debug("REAL");
//            case Types.REF :
//                log__.debug("REF");
//            case Types.SMALLINT :
//                log__.debug("SMALLINT");
//            case Types.STRUCT :
//                log__.debug("STRUCT");
//            case Types.TIME :
//                log__.debug("TIME");
//            case Types.TIMESTAMP :
//                log__.debug("TIMESTAMP");
//            case Types.TINYINT :
//                log__.debug("TINYINT");
//            case Types.VARBINARY :
//                log__.debug("VARBINARY");
//            case Types.VARCHAR :
//                log__.debug("VARCHAR");
//                ret = "varchar(" + size + ")";
//                break;
//            default :
//                log__.debug("UNKNOWN");
//                ret = "UNKNOWN";
//        }
//
//        //Not Null
//        String notNull = "";
//        if (java.sql.DatabaseMetaData.columnNoNulls == col.getNullable()) {
//            notNull = " not null";
//        }
//        ret += notNull;
//
//        log__.debug(col.getName() + " type = " + ret + "| " + col.getType());
//        log__.debug(col.getName() + " size = " + size);
//
//        return ret;
//    }

    /**
     * <p>ftHgRXgN^𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createConstructor(ArrayList<String> source) {
        String tblName = table__.getName();
        String clsName = __createModelClassName(tblName);

        //NX錾
        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>Default Constructor");
        source.add(GenConst.INDENT + " */");
        //
        String line = GenConst.INDENT + "public " + clsName + "() {";
        source.add(line);
        source.add(GenConst.INDENT + "}");
        //s
        source.add("");
        return source;
    }

    /**
     * <p>Qb^[AZb^[쐬܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createGetSeter(ArrayList<String> source) {
        ArrayList cols = table__.getColumns();
        Iterator it = cols.iterator();
        while (it.hasNext()) {
            Column col = (Column) it.next();
            __createGetter(source, col);
            __createSetter(source, col);
        }
        return source;
    }

    /**
     * <p>Qb^[쐬܂B
     * @param source \[X
     * @param col 
     * @return \[X
     */
    private ArrayList __createGetter(ArrayList<String> source, Column col) {
        //e[u
        String colName = col.getName();

        //JavatB[h
        String fldName = GenUtil.createFieldName(colName);

        //Java^
        int type = col.getType();
        String typeStr = GenUtil.getTypeNameJdbc(type);

        //̖
        String hName = GenUtil.createFieldName2(colName);

        //JavaDocRg
        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>get " + colName + " value");
        source.add(GenConst.INDENT + " * @return " + colName + " value");
        source.add(GenConst.INDENT + " */");

        //\bh錾
        String methodName = GenUtil.createMethodName(true, colName);
        source.add(GenConst.INDENT + "public " + typeStr + " " + methodName + "() {");

        //return
        source.add(GenConst.INDENT + GenConst.INDENT + "return " + fldName + ";");

        //
        source.add(GenConst.INDENT + "}");
        source.add("");
        return source;
    }

    /**
     * <p>Zb^[쐬܂B
     * @param source \[X
     * @param col 
     * @return \[X
     */
    private ArrayList __createSetter(ArrayList<String> source, Column col) {
        //e[u
        String colName = col.getName();

        //JavatB[h
        String fldName = GenUtil.createFieldName(colName);

        //Java^
        int type = col.getType();
        String typeStr = GenUtil.getTypeNameJdbc(type);

        //̖
        String hName = GenUtil.createFieldName2(colName);

        //JavaDocRg
        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>set " + colName + " value");
        source.add(GenConst.INDENT + " * @param " + hName + " " + colName + " value");
        source.add(GenConst.INDENT + " */");

        //\bh錾
        String methodName = GenUtil.createMethodName(false, colName);
        source.add(
            GenConst.INDENT + "public void " + methodName + "(" + typeStr + " " + hName + ") {");

        //return
        source.add(GenConst.INDENT + GenConst.INDENT + fldName + " = " + hName + ";");

        //
        source.add(GenConst.INDENT + "}");
        source.add("");
        return source;
    }

    /**
     * <p>beanCSV`Ԃ܂
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createCsvString(ArrayList<String> source) {
        ArrayList cols = table__.getColumns();
        Iterator it = cols.iterator();

        //JavaDocRg
        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>to Csv String");
        source.add(GenConst.INDENT + " * @return Csv String");
        source.add(GenConst.INDENT + " */");

        //\bh錾
        source.add(
            GenConst.INDENT + "public String toCsvString() {");
        //StringBuffer
        source.add(GenUtil.getIndent(2) + "StringBuffer buf = new StringBuffer();");
        while (it.hasNext()) {
            Column col = (Column) it.next();
            //e[u
            String colName = col.getName();
            //JavatB[h
            String fldName = GenUtil.createFieldName(colName);
            //Java^
            int type = col.getType();
            String typeStr = GenUtil.getTypeNameJdbc(type);
            //
            if (typeStr.equals("int") || typeStr.equals("double") || typeStr.equals("long")) {
                //int,double,long
                source.add(GenUtil.getIndent(2) + "buf.append(" + fldName + ");");
            } else if (typeStr.equals("String")) {
                // String
                source.add(GenUtil.getIndent(2)
                        + "buf.append(NullDefault.getString(" + fldName
                        + ", \"\"));");
            } else if (typeStr.equals("UDate")) {
                // UDate
                source.add(GenUtil.getIndent(2)
                        + "buf.append(NullDefault.getStringFmObj(" + fldName
                        + ", \"\"));");
            } else {
                // ̑
                source.add(GenUtil.getIndent(2)
                        + "buf.append(NullDefault.getStringFmObj(" + fldName
                        + ", \"\"));");
            }
            if (it.hasNext()) {
                source.add(GenUtil.getIndent(2) + "buf.append(\",\");");
            }
        }
        //߂l
        source.add(GenUtil.getIndent(2) + "return buf.toString();");
        //
        source.add(GenConst.INDENT + "}");
        source.add("");
        return source;
    }

    /**
     * <br>[@  \] classNameFlg𔻒肵܂B
     * <br>[  ]
     * <br>[  l]
     * @return classNameFlg
     */
    public boolean isClassNameFlg() {
        return classNameFlg__;
    }

    /**
     * <br>[@  \] classNameFlgZbg܂
     * <br>[  ]
     * <br>[  l]
     * @param classNameFlg classNameFlg
     */
    public void setClassNameFlg(boolean classNameFlg) {
        this.classNameFlg__ = classNameFlg;
    }
}
