/*
 * create   : 2004/08/02
 * modified :
 */
package jp.groupsession.v2.dba.core;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import jp.co.sjts.util.StringUtil;
import jp.groupsession.v2.dba.meta.Column;
import jp.groupsession.v2.dba.meta.Table;

/**
 * <br>[@  \] DaoNX𐶐܂B
 * <br>[  ]
 * <br>[  l]
 * @author JTS
 */
public class DaoGenerator {
    /** e[uIuWFNg */
    private Table table__ = null;
    /** SqlGenerator */
    private AbstractSqlGenerator sqlGen__ = null;
    /** pbP[W */
    private String packageName__ = null;
    /** fpbP[W */
    private String modelPackageName__ = null;
    /** DaoNXe[u + Dao ł̂܂܎gptO true:̂܂܎gp, false:ϊ */
    private boolean daoClassNameFlg__ = false;
    /** ModelNXe[u + Model ł̂܂܎gptO true:̂܂܎gp, false:ϊ */
    private boolean modelClassNameFlg__ = false;

    /**
     * <p>ftHgRXgN^
     */
    public DaoGenerator() {
    }

    /**
     * <p>e[uZbg܂
     * @param table e[u
     */
    public DaoGenerator(Table table) {
        table__ = table;
    }

    /**
     * <p>e[uZbg܂
     * @param table e[u
     * @param sqlGen SqlGenerator
     */
    public DaoGenerator(Table table, AbstractSqlGenerator sqlGen) {
        table__ = table;
        sqlGen__ = sqlGen;
    }

    /**
     * <p>e[u擾܂B
     * @return e[u
     */
    public Table getTable() {
        return table__;
    }

    /**
     * <p>e[uZbg܂B
     * @param table e[u
     */
    public void setTable(Table table) {
        table__ = table;
    }

    /**
     * <p>DaoJava\[X𐶐܂B
     * @return Java\[X
     */
    public String generate() {
        //
        ArrayList<String> source = new ArrayList<String>();

        //pbP[W𐶐
        __createPackage(source);

        //imports𐶐
        __createImport(source);

        //NX̍s𐶐
        __createClassName(source);

        //OCX^Xs𐶐
        __createLogger(source);

        //RXgN^̐
        __createConstructor(source);

        //Drop Table ̍쐬
        __createDropSql(source);

        //Create Table ̍쐬
        __createCreateSql(source);

        //Insert ̍쐬
        __createInsertSql(source);

        //Update ̍쐬
        __createUpdateSql(source);

        //Select ̍쐬(S)
        __createSelectAllSql(source);

        //Select ̍쐬(L[Ō)
        __createSelectSql(source);

        //Delete ̍쐬(L[ō폜)
        __createDeleteSql(source);

        //R[hZbgAr[쐬郁\bh𐶐
        //selectŎgp
        __createSelectBeanFromRs(source);

        //tb^[ }̂ݐ
        source.add("}");
        return StringUtil.toStringByList(source);
    }

    /**
     * <p>DaoJava\[X𐶐܂B(CӂSelect̂)
     * @param sqlLines SQL
     * @return Java\[X
     */
    public String generateSelect(List<String> sqlLines) {
        //
        ArrayList<String> source = new ArrayList<String>();

        //pbP[W𐶐
        __createPackage(source);

        //imports𐶐
        __createImport(source);

        //NX̍s𐶐
        __createClassName(source);

        //OCX^Xs𐶐
        __createLogger(source);

        //RXgN^̐
        __createConstructor(source);

        //Select ̍쐬(CӂSQL)
        __createSelectAllSql(source, sqlLines);

        //R[hZbgAr[쐬郁\bh𐶐
        //selectŎgp
        __createSelectBeanFromRs(source);

        //tb^[ }̂ݐ
        source.add("}");
        return StringUtil.toStringByList(source);
    }

    /**
     * <p>pbP[W錾𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createPackage(ArrayList<String> source) {
        String pkg = null;
        pkg = getPackageName();
        String line = null;
        if (pkg == null) {
            pkg = TypeMappingResourceBundle.getString("package");
            line = "package " + pkg + ";";
        } else if (pkg.trim().length() <= 0) {
            line = "";
        } else {
            line = "package " + pkg + ";";
        }

        //pbP[W錾
        source.add(line);
        //s
        source.add("");
        return source;
    }

    /**
     * <p>import錾𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createImport(ArrayList<String> source) {

        HashMap<String, String> hm = new HashMap<String, String>();
        ArrayList cols = table__.getColumns();
        Iterator it = cols.iterator();
        while (it.hasNext()) {
            Column col = (Column) it.next();
            int type = col.getType();
            String typeFqdn = GenUtil.getTypeNameJdbcFQDN(type);
            if (!StringUtil.isNullZeroString(typeFqdn)) {
                hm.put(typeFqdn, "");
                //source.add("import " + typeFqdn + ";");
            }
        }
        //
        Set kset = hm.keySet();
        Iterator it2 = kset.iterator();
        while (it2.hasNext()) {
            String imtgt = (String) it2.next();
            if (imtgt.endsWith("long")) {
                //long̓C|[głȂ̂ŏO
            } else if (imtgt.endsWith("int")) {
                //int̓C|[głȂ̂ŏO
            } else if (imtgt.endsWith("double")) {
                //double̓C|[głȂ̂ŏO
            } else {
                source.add("import " + imtgt + ";");
            }
        }

        //AbstractDao͕K{
        source.add("import java.sql.Connection;");
        source.add("import java.sql.PreparedStatement;");
        source.add("import java.sql.ResultSet;");
        source.add("import java.sql.SQLException;");
        source.add("import java.util.List;");
        source.add("import java.util.ArrayList;");
        source.add("import org.apache.commons.logging.Log;");
        source.add("import org.apache.commons.logging.LogFactory;");
        source.add("import " + TypeMappingResourceBundle.getString("JDBCUtil") + ";");
        source.add("import " + TypeMappingResourceBundle.getString("AbstractDao") + ";");
        source.add("import " + TypeMappingResourceBundle.getString("SqlBuffer") + ";");
//        source.add("import "
//                + TypeMappingResourceBundle.getString("DataNotFoundException")
//                + ";");

        //
        if (packageName__ != null && !packageName__.equals(modelPackageName__)) {
            //DaoModel̃pbP[WقȂꍇ
            String tblName = table__.getName();
            String modelName = __createModelClassName(tblName);
            source.add("import " + modelPackageName__ + "." + modelName + ";");
        }
        source.add("");
        return source;
    }

    /**
     * fNXԂ
     * @param tableName e[u
     * @return fNX
     */
    private String __createModelClassName(String tableName) {
        if (modelClassNameFlg__) {
            return tableName + "Model";
        } else {
            return GenUtil.createClassName(tableName, false,
                    TypeMappingResourceBundle.getString("table_prefix"));
        }
    }

    /**
     * <br>[@  \] DaoNXԂB
     * <br>[  ]
     * <br>[  l]
     * @param tableName e[u
     * @return DaoNX
     */
    private String __createDaoClassName(String tableName) {
        String clsName = null;
        if (daoClassNameFlg__) {
            clsName = tableName + "Dao";
        } else {
            clsName = GenUtil.createClassName(tableName, true,
                    TypeMappingResourceBundle.getString("table_prefix"));
        }
        return clsName;
    }

    /**
     * <p>NX錾𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createClassName(ArrayList<String> source) {
        String tblName = table__.getName();
        String clsName = null;

        clsName = __createDaoClassName(tblName);

        //
        String line = "public class " + clsName + " extends AbstractDao {";

        //NX錾 
        source.add("/**");
        source.add(" * <p>" + tblName + " Data Access Object");
        source.add(" *");
        source.add(" * @author " + GenConst.PRODUCT_NAME + " version " + GenConst.VERSION);
        source.add(" */");
        source.add(line);
        //s
        source.add("");
        return source;
    }
    /**
     * <p>Oo͂̐錾\[X𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createLogger(ArrayList<String> source) {
        String tblName = table__.getName();
        String clsName = __createDaoClassName(tblName);
        //
        source.add(GenConst.INDENT + "/** Logging CX^X */");
        source.add(GenConst.INDENT
                + "private static Log log__ = LogFactory.getLog(" + clsName
                + ".class);");
        //s
        source.add("");
        return source;
    }

    /**
     * <p>RXgN^𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createConstructor(ArrayList<String> source) {
        String tblName = table__.getName();
        String clsName = __createDaoClassName(tblName);

        //NX錾 
        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>Default Constructor");
        source.add(GenConst.INDENT + " */");
        //
        source.add(GenConst.INDENT + "public " + clsName + "() {");
        source.add(GenConst.INDENT + "}");
        //s
        source.add("");

        //NX錾 RlNV
        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>Set Connection");
        source.add(GenConst.INDENT + " * @param con Connection");
        source.add(GenConst.INDENT + " */");
        //
        source.add(GenConst.INDENT + "public " + clsName + "(Connection con) {");
        source.add(GenUtil.getIndent(2) + "super(con);");
        source.add(GenConst.INDENT + "}");
        //s
        source.add("");
        return source;
    }

    /**
     * <p>Drop Table 𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createDropSql(ArrayList<String> source) {
        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>Drop Table");
        source.add(GenConst.INDENT + " * @throws SQLException SQLsO");
        source.add(GenConst.INDENT + " */");
        source.add(GenConst.INDENT + "public void dropTable() throws SQLException {");
        source.add("");
        source.add(GenUtil.getIndent(2) + "PreparedStatement pstmt = null;");
//        source.add(GenUtil.getIndent(2) + "int count = 0;");
        source.add(GenUtil.getIndent(2) + "Connection con = null;");
        source.add(GenUtil.getIndent(2) + "con = getCon();");
        source.add("");
        source.add(GenUtil.getIndent(2) + "try {");
        source.add(GenUtil.getIndent(2) + "    //SQL");
        source.add(GenUtil.getIndent(2) + "    SqlBuffer sql = new SqlBuffer();");

        //SQL
        List sql = sqlGen__.generateDropTableSqlList();
        Iterator it = sql.iterator();
        while (it.hasNext()) {
            //
            String line = (String) it.next();
            line = GenUtil.escapeSrc(line);
            source.add(GenUtil.getIndent(3) + "sql.addSql(\"" + line + "\");");
        }

        source.add("");
        source.add(GenUtil.getIndent(2) + "    pstmt = con.prepareStatement(sql.toSqlString());");
        source.add(GenUtil.getIndent(2) + "    log__.info(sql.toLogString());");
//        source.add(GenUtil.getIndent(2) + "    count = pstmt.executeUpdate();");
        source.add(GenUtil.getIndent(2) + "    pstmt.executeUpdate();");
        source.add(GenUtil.getIndent(2) + "} catch (SQLException e) {");
        source.add(GenUtil.getIndent(2) + "    throw e;");
        source.add(GenUtil.getIndent(2) + "} finally {");
        source.add(GenUtil.getIndent(2) + "    JDBCUtil.closeStatement(pstmt);");
        source.add(GenUtil.getIndent(2) + "}");

        source.add(GenConst.INDENT + "}");
        source.add("");
        return source;
    }

    /**
     * <p>Create Table𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createCreateSql(ArrayList<String> source) {
        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>Create Table");
        source.add(GenConst.INDENT + " * @throws SQLException SQLsO");
        source.add(GenConst.INDENT + " */");
        source.add(GenConst.INDENT + "public void createTable() throws SQLException {");
        source.add("");
        source.add(GenUtil.getIndent(2) + "PreparedStatement pstmt = null;");
//        source.add(GenUtil.getIndent(2) + "int count = 0;");
        source.add(GenUtil.getIndent(2) + "Connection con = null;");
        source.add(GenUtil.getIndent(2) + "con = getCon();");
        source.add("");
        source.add(GenUtil.getIndent(2) + "try {");
        source.add(GenUtil.getIndent(2) + "    //SQL");
        source.add(GenUtil.getIndent(2) + "    SqlBuffer sql = new SqlBuffer();");

        //SQL
        List sql = sqlGen__.generateCreateTableSqlList();
        Iterator it = sql.iterator();
        while (it.hasNext()) {
            //
            String line = (String) it.next();
            line = GenUtil.escapeSrc(line);
            source.add(GenUtil.getIndent(3) + "sql.addSql(\"" + line + "\");");
        }

        source.add("");
        source.add(GenUtil.getIndent(2) + "    pstmt = con.prepareStatement(sql.toSqlString());");
        source.add(GenUtil.getIndent(2) + "    log__.info(sql.toLogString());");
        source.add(GenUtil.getIndent(2) + "    pstmt.executeUpdate();");
//        source.add(GenUtil.getIndent(2) + "    count = pstmt.executeUpdate();");
        source.add(GenUtil.getIndent(2) + "} catch (SQLException e) {");
        source.add(GenUtil.getIndent(2) + "    throw e;");
        source.add(GenUtil.getIndent(2) + "} finally {");
        source.add(GenUtil.getIndent(2) + "    JDBCUtil.closeStatement(pstmt);");
        source.add(GenUtil.getIndent(2) + "}");

        source.add(GenConst.INDENT + "}");
        source.add("");
        return source;
    }

    /**
     * <p>Insert𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createInsertSql(ArrayList<String> source) {
        //e[u
        String tblName = table__.getName();
        //BEAN
        String bean = __createModelClassName(tblName);

        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>Insert " + tblName + " Data Bindding JavaBean");
        source.add(GenConst.INDENT + " * @param bean " + tblName + " Data Bindding JavaBean");
        source.add(GenConst.INDENT + " * @throws SQLException SQLsO");
        source.add(GenConst.INDENT + " */");
        source.add(GenConst.INDENT + "public void insert(" + bean + " bean) throws SQLException {");
        source.add("");
        source.add(GenUtil.getIndent(2) + "PreparedStatement pstmt = null;");
//        source.add(GenUtil.getIndent(2) + "int count = 0;");
        source.add(GenUtil.getIndent(2) + "Connection con = null;");
        source.add(GenUtil.getIndent(2) + "con = getCon();");
        source.add("");
        source.add(GenUtil.getIndent(2) + "try {");
        source.add(GenUtil.getIndent(2) + "    //SQL");
        source.add(GenUtil.getIndent(2) + "    SqlBuffer sql = new SqlBuffer();");

        //SQL
        List sql = sqlGen__.generateInsertSqlList();
        Iterator it = sql.iterator();
        while (it.hasNext()) {
            //
            String line = (String) it.next();
            line = GenUtil.escapeSrc(line);
            source.add(GenUtil.getIndent(3) + "sql.addSql(\"" + line + "\");");
        }
        source.add("");
        source.add(GenUtil.getIndent(2) + "    pstmt = con.prepareStatement(sql.toSqlString());");

        //lZbg
        ArrayList cols = table__.getColumns();
        Iterator it2 = cols.iterator();
        int cnt = 0;
        while (it2.hasNext()) {
            cnt++;
            Column col = (Column) it2.next();
            //beanGET\bh擾
            String colName = col.getName();
            String gmethodName = GenUtil.createMethodName(true, colName);

            //PrepareStatementSet\bh擾
            String smethodName = GenUtil.getSetMethodNameOfPstmt(col.getType());

            //^ϊp\bh擾
            String rep = "bean." + gmethodName + "()";
//            String castMethod = GenUtil.getSetTypeCastMethodName(col.getType(), rep);
//            if (castMethod == null) {
                source.add(
                    GenUtil.getIndent(2)
                        + "    sql.addValue"
                        + "("
                        + rep
                        + ");");
//            } else {
//                source.add(
//                    GenUtil.getIndent(2)
//                        + "    sql.addValue"
//                        + "("
//                        + castMethod
//                        + ");");
//            }
        }
        source.add(GenUtil.getIndent(2) + "    log__.info(sql.toLogString());");
        source.add(GenUtil.getIndent(2) + "    sql.setParameter(pstmt);");
        source.add(GenUtil.getIndent(2) + "    pstmt.executeUpdate();");
//        source.add(GenUtil.getIndent(2) + "    count = pstmt.executeUpdate();");
        source.add(GenUtil.getIndent(2) + "} catch (SQLException e) {");
        source.add(GenUtil.getIndent(2) + "    throw e;");
        source.add(GenUtil.getIndent(2) + "} finally {");
        source.add(GenUtil.getIndent(2) + "    JDBCUtil.closeStatement(pstmt);");
        source.add(GenUtil.getIndent(2) + "}");

        source.add(GenConst.INDENT + "}");
        source.add("");
        return source;
    }

    /**
     * <p>Update𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createUpdateSql(ArrayList<String> source) {
        //e[u
        String tblName = table__.getName();
        //BEAN
        String bean = __createModelClassName(tblName);

        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>Update " + tblName + " Data Bindding JavaBean");
        source.add(GenConst.INDENT + " * @param bean " + tblName + " Data Bindding JavaBean");
        source.add(GenConst.INDENT + " * @return XV");
        source.add(GenConst.INDENT + " * @throws SQLException SQLsO");
        source.add(GenConst.INDENT + " */");
        source.add(GenConst.INDENT + "public int update(" + bean + " bean) throws SQLException {");
        source.add("");
        source.add(GenUtil.getIndent(2) + "PreparedStatement pstmt = null;");
        source.add(GenUtil.getIndent(2) + "int count = 0;");
        source.add(GenUtil.getIndent(2) + "Connection con = null;");
        source.add(GenUtil.getIndent(2) + "con = getCon();");
        source.add("");
        source.add(GenUtil.getIndent(2) + "try {");
        source.add(GenUtil.getIndent(2) + "    //SQL");
        source.add(GenUtil.getIndent(2) + "    SqlBuffer sql = new SqlBuffer();");

        //SQL
        List sql = sqlGen__.generateUpdateSqlList();
        Iterator it = sql.iterator();
        while (it.hasNext()) {
            //
            String line = (String) it.next();
            line = GenUtil.escapeSrc(line);
            source.add(GenUtil.getIndent(3) + "sql.addSql(\"" + line + "\");");
        }
        source.add("");
        source.add(GenUtil.getIndent(2) + "    pstmt = con.prepareStatement(sql.toSqlString());");

        //lZbg
        ArrayList cols = table__.getColumns();
        Iterator it2 = cols.iterator();
        int cnt = 0;
        while (it2.hasNext()) {
            Column col = (Column) it2.next();
            if (col.getSeqKey() > 0) {
                continue;
            }
            cnt++;
            //beanGET\bh擾
            String colName = col.getName();
            String gmethodName = GenUtil.createMethodName(true, colName);

            //PrepareStatementSet\bh擾
            String smethodName = GenUtil.getSetMethodNameOfPstmt(col.getType());

            //^ϊp\bh擾
            String rep = "bean." + gmethodName + "()";
//            String castMethod = GenUtil.getSetTypeCastMethodName(col.getType(), rep);
//            if (castMethod == null) {
                source.add(
                    GenUtil.getIndent(2)
                        + "    sql.addValue"
                        + "("
                        + rep
                        + ");");
//            } else {
//                source.add(
//                    GenUtil.getIndent(2)
//                        + "    sql.addValue"
//                        + "("
//                        + castMethod
//                        + ");");
//            }
        }
        //PrimaryKey
        ArrayList keys = table__.getPkey();
        if (!keys.isEmpty()) {
            source.add(GenUtil.getIndent(3) + "//where");
            Iterator it3 = keys.iterator();
            while (it3.hasNext()) {
                cnt++;
                Column col = (Column) it3.next();
                String mnameSetter = "sql.addValue";
                //R[hZbgBEAN擾郁\bh
                mnameSetter
                    += "("
                    +  "bean." + GenUtil.createMethodName(true, col.getName() + "()")
                    +  ");";
                source.add(GenUtil.getIndent(3) + mnameSetter);
            }
        }
        source.add("");

        source.add(GenUtil.getIndent(2) + "    log__.info(sql.toLogString());");
        source.add(GenUtil.getIndent(2) + "    sql.setParameter(pstmt);");
        source.add(GenUtil.getIndent(2) + "    count = pstmt.executeUpdate();");
        source.add(GenUtil.getIndent(2) + "} catch (SQLException e) {");
        source.add(GenUtil.getIndent(2) + "    throw e;");
        source.add(GenUtil.getIndent(2) + "} finally {");
        source.add(GenUtil.getIndent(2) + "    JDBCUtil.closeStatement(pstmt);");
        source.add(GenUtil.getIndent(2) + "}");
        source.add(GenUtil.getIndent(2) + "return count;");

        source.add(GenConst.INDENT + "}");
        source.add("");
        return source;
    }

    /**
     * <p>SẴR[h擾Select𐶐܂B
     * @param source \[X
     * @return \[X
     */
    private ArrayList __createSelectAllSql(ArrayList<String> source) {
        //e[u
        String tblName = table__.getName();
        //BEAN
        String bean = __createModelClassName(tblName);

        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>Select " + tblName + " All Data");
        source.add(GenConst.INDENT + " * @return List in " + tblName + "Model");
        source.add(GenConst.INDENT + " * @throws SQLException SQLsO");
        source.add(GenConst.INDENT + " */");
        source.add(GenConst.INDENT + "public List select() throws SQLException {");
        source.add("");
        source.add(GenUtil.getIndent(2) + "PreparedStatement pstmt = null;");
        source.add(GenUtil.getIndent(2) + "ResultSet rs = null;");
        source.add(GenUtil.getIndent(2) + "Connection con = null;");
        source.add(GenUtil.getIndent(2) + "ArrayList ret = new ArrayList();");
        source.add(GenUtil.getIndent(2) + "con = getCon();");
        source.add("");
        source.add(GenUtil.getIndent(2) + "try {");
        source.add(GenUtil.getIndent(2) + "    //SQL");
        source.add(GenUtil.getIndent(2) + "    SqlBuffer sql = new SqlBuffer();");

        //SQL
        List sql = sqlGen__.generateSelectSqlAllList();
        Iterator it = sql.iterator();
        while (it.hasNext()) {
            //
            String line = (String) it.next();
            line = GenUtil.escapeSrc(line);
            source.add(GenUtil.getIndent(3) + "sql.addSql(\"" + line + "\");");
        }
        source.add("");
        source.add(GenUtil.getIndent(2) + "    pstmt = con.prepareStatement(sql.toSqlString());");
        source.add(GenUtil.getIndent(2) + "    log__.info(sql.toLogString());");
        source.add(GenUtil.getIndent(2) + "    rs = pstmt.executeQuery();");
        source.add(GenUtil.getIndent(2) + "    while (rs.next()) {");

        //R[hZbgBEAN擾郁\bh
        String mnameRs =
            GenUtil.createResultsetGetterName(
                tblName,
                TypeMappingResourceBundle.getString("table_prefix"));
        source.add(GenUtil.getIndent(2) + "        ret.add(" + mnameRs + "(rs));");
        source.add(GenUtil.getIndent(2) + "    }");
        source.add(GenUtil.getIndent(2) + "} catch (SQLException e) {");
        source.add(GenUtil.getIndent(2) + "    throw e;");
        source.add(GenUtil.getIndent(2) + "} finally {");
        source.add(GenUtil.getIndent(2) + "    JDBCUtil.closeResultSet(rs);");
        source.add(GenUtil.getIndent(2) + "    JDBCUtil.closeStatement(pstmt);");
        source.add(GenUtil.getIndent(2) + "}");
        source.add(GenUtil.getIndent(2) + "return ret;");
        source.add(GenConst.INDENT + "}");
        source.add("");
        return source;
    }

    /**
     * <p>SẴR[h擾Select𐶐܂B
     * @param source \[X
     * @param cSql CӂSQL
     * @return \[X
     */
    private ArrayList __createSelectAllSql(ArrayList<String> source, List cSql) {
        //e[u
        String tblName = table__.getName();
        //BEAN
        String bean = __createModelClassName(tblName);

        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>Select " + tblName + " All Data");
        source.add(GenConst.INDENT + " * @return List in " + tblName + "Model");
        source.add(GenConst.INDENT + " * @throws SQLException SQLsO");
        source.add(GenConst.INDENT + " */");
        source.add(GenConst.INDENT + "public List select() throws SQLException {");
        source.add("");
        source.add(GenUtil.getIndent(2) + "PreparedStatement pstmt = null;");
        source.add(GenUtil.getIndent(2) + "ResultSet rs = null;");
        source.add(GenUtil.getIndent(2) + "Connection con = null;");
        source.add(GenUtil.getIndent(2) + "ArrayList ret = new ArrayList();");
        source.add(GenUtil.getIndent(2) + "con = getCon();");
        source.add("");
        source.add(GenUtil.getIndent(2) + "try {");
        source.add(GenUtil.getIndent(2) + "    //SQL");
        source.add(GenUtil.getIndent(2) + "    SqlBuffer sql = new SqlBuffer();");

        //SQL
        List sql = cSql;
        Iterator it = sql.iterator();
        while (it.hasNext()) {
            //
            String line = (String) it.next();
            line = GenUtil.escapeSrc(line);
            source.add(GenUtil.getIndent(3) + "sql.addSql(\"" + line + "\");");
        }
        source.add("");
        source.add(GenUtil.getIndent(2) + "    log__.info(sql.toLogString());");
        source.add(GenUtil.getIndent(2) + "    pstmt = con.prepareStatement(sql.toSqlString());");
        source.add(GenUtil.getIndent(2) + "    sql.setParameter(pstmt);");
        source.add(GenUtil.getIndent(2) + "    rs = pstmt.executeQuery();");
        source.add(GenUtil.getIndent(2) + "    while (rs.next()) {");

        //R[hZbgBEAN擾郁\bh
        String mnameRs =
            GenUtil.createResultsetGetterName(
                tblName,
                TypeMappingResourceBundle.getString("table_prefix"));
        source.add(GenUtil.getIndent(2) + "        ret.add(" + mnameRs + "(rs));");
        source.add(GenUtil.getIndent(2) + "    }");
        source.add(GenUtil.getIndent(2) + "} catch (SQLException e) {");
        source.add(GenUtil.getIndent(2) + "    throw e;");
        source.add(GenUtil.getIndent(2) + "} finally {");
        source.add(GenUtil.getIndent(2) + "    JDBCUtil.closeResultSet(rs);");
        source.add(GenUtil.getIndent(2) + "    JDBCUtil.closeStatement(pstmt);");
        source.add(GenUtil.getIndent(2) + "}");
        source.add(GenUtil.getIndent(2) + "return ret;");
        source.add(GenConst.INDENT + "}");
        source.add("");
        return source;
    }

    /**
     * <p>vC}[L[ɂSelect𐶐܂B
     * @param source \[X
     * @return \[X
     */
    @SuppressWarnings("unchecked")
    private ArrayList __createSelectSql(ArrayList<String> source) {
        //e[u
        String tblName = table__.getName();
        //BEAN
        String bean = __createModelClassName(tblName);

        //p[^IuWFNg̍쐬
        ArrayList keys = table__.getPkey();
        ArrayList params = new ArrayList();
        if (keys.isEmpty()) {
            //L[Ȃ̏ꍇ͋̃XgԂ
            return new ArrayList();
        } else {
            //̌^擾
            Iterator it2 = keys.iterator();
            while (it2.hasNext()) {
                Column col = (Column) it2.next();
                //f[^^
                String type = GenUtil.getTypeNameJdbc(col.getType());
                //ϐ
                String paramName = GenUtil.createParamName(col.getName());
                JavaParamModel model = new JavaParamModel();
                model.setTypeName(type);
                model.setParamName(paramName);
                model.setCol(col);
                params.add(model);
            }
        }

        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>Select " + tblName);

        //JavaDoc𐶐
        StringBuffer paramBuf = new StringBuffer();
        Iterator paramIt = params.iterator();
        int pcnt = 0;
        while (paramIt.hasNext()) {
            pcnt++;
            JavaParamModel model = (JavaParamModel) paramIt.next();
            // JavaDocRg
            source.add(GenConst.INDENT + " * @param " + model.getParamName()
                    + " " + model.getCol().getName());
            // 
            if (pcnt > 1) {
                paramBuf.append(", ");
            }
            paramBuf.append(model.getTypeName() + " " + model.getParamName());
        }

        source.add(GenConst.INDENT + " * @return " + tblName + "Model");
        source.add(GenConst.INDENT + " * @throws SQLException SQLsO");
        source.add(GenConst.INDENT + " */");
        source.add(
            GenConst.INDENT
                + "public "
                + bean
                + " select("
                + paramBuf.toString()
                + ") throws SQLException {");
        source.add("");
        source.add(GenUtil.getIndent(2) + "PreparedStatement pstmt = null;");
        source.add(GenUtil.getIndent(2) + "ResultSet rs = null;");
        source.add(GenUtil.getIndent(2) + "Connection con = null;");
        source.add(GenUtil.getIndent(2) + bean + " ret = null;");
        source.add(GenUtil.getIndent(2) + "con = getCon();");
        source.add("");
        source.add(GenUtil.getIndent(2) + "try {");
        source.add(GenUtil.getIndent(2) + "    //SQL");
        source.add(GenUtil.getIndent(2) + "    SqlBuffer sql = new SqlBuffer();");

        //SQL
        List sql = sqlGen__.generateSelectSqlList();
        Iterator it = sql.iterator();
        while (it.hasNext()) {
            //
            String line = (String) it.next();
            line = GenUtil.escapeSrc(line);
            source.add(GenUtil.getIndent(3) + "sql.addSql(\"" + line + "\");");
        }
        source.add("");
        source.add(GenUtil.getIndent(3) + "pstmt = con.prepareStatement(sql.toSqlString());");

        //PrimaryKey
        paramIt = params.iterator();
        while (paramIt.hasNext()) {
            pcnt++;
            JavaParamModel model = (JavaParamModel) paramIt.next();
            String mnameSetter = "sql.addValue";
            //R[hZbgBEAN擾郁\bh
            mnameSetter
                += "("
                + model.getParamName()
                +  ");";
            //
            source.add(GenUtil.getIndent(3) + mnameSetter);
        }
        source.add("");
        source.add(GenUtil.getIndent(2) + "    log__.info(sql.toLogString());");
        source.add(GenUtil.getIndent(2) + "    sql.setParameter(pstmt);");
        source.add(GenUtil.getIndent(2) + "    rs = pstmt.executeQuery();");
        source.add(GenUtil.getIndent(2) + "    if (rs.next()) {");

        //R[hZbgBEAN擾郁\bh
        String mnameRs =
            GenUtil.createResultsetGetterName(
                tblName,
                TypeMappingResourceBundle.getString("table_prefix"));
        source.add(GenUtil.getIndent(2) + "        ret = " + mnameRs + "(rs);");
        source.add(GenUtil.getIndent(2) + "    }");
        source.add(GenUtil.getIndent(2) + "} catch (SQLException e) {");
        source.add(GenUtil.getIndent(2) + "    throw e;");
        source.add(GenUtil.getIndent(2) + "} finally {");
        source.add(GenUtil.getIndent(2) + "    JDBCUtil.closeResultSet(rs);");
        source.add(GenUtil.getIndent(2) + "    JDBCUtil.closeStatement(pstmt);");
        source.add(GenUtil.getIndent(2) + "}");
        source.add(GenUtil.getIndent(2) + "return ret;");
        source.add(GenConst.INDENT + "}");
        source.add("");
        return source;
    }

    /**
     * <p>vC}[L[ɂDelete𐶐܂B
     * @param source \[X
     * @return \[X
     */
    @SuppressWarnings("unchecked")
    private ArrayList __createDeleteSql(ArrayList<String> source) {
        //e[u
        String tblName = table__.getName();
        //BEAN
        String bean = __createModelClassName(tblName);

        //p[^IuWFNg̍쐬
        ArrayList keys = table__.getPkey();
        ArrayList params = new ArrayList();
        if (keys.isEmpty()) {
            // L[Ȃ̏ꍇ͋̃XgԂ
            return new ArrayList();
        } else {
            //̌^擾
            Iterator it2 = keys.iterator();
            while (it2.hasNext()) {
                Column col = (Column) it2.next();
                //f[^^
                String type = GenUtil.getTypeNameJdbc(col.getType());
                //ϐ
                String paramName = GenUtil.createParamName(col.getName());
                JavaParamModel model = new JavaParamModel();
                model.setTypeName(type);
                model.setParamName(paramName);
                model.setCol(col);
                params.add(model);
            }
        }

        source.add(GenConst.INDENT + "/**");
        source.add(GenConst.INDENT + " * <p>Delete " + tblName);

        //JavaDoc𐶐
        StringBuffer paramBuf = new StringBuffer();
        Iterator paramIt = params.iterator();
        int pcnt = 0;
        while (paramIt.hasNext()) {
            pcnt++;
            JavaParamModel model = (JavaParamModel) paramIt.next();
            // JavaDocRg
            source.add(GenConst.INDENT + " * @param " + model.getParamName()
                    + " " + model.getCol().getName());
            // 
            if (pcnt > 1) {
                paramBuf.append(", ");
            }
            paramBuf.append(model.getTypeName() + " " + model.getParamName());
        }


        source.add(GenConst.INDENT + " * @throws SQLException SQLsO");
        source.add(GenConst.INDENT + " */");
        source.add(
            GenConst.INDENT
                + "public"
                + " int"
                + " delete("
                + paramBuf.toString()
                + ") throws SQLException {");
        source.add("");
        source.add(GenUtil.getIndent(2) + "PreparedStatement pstmt = null;");
//        source.add(GenUtil.getIndent(2) + "ResultSet rs = null;");
        source.add(GenUtil.getIndent(2) + "int count = 0;");
        source.add(GenUtil.getIndent(2) + "Connection con = null;");
        source.add(GenUtil.getIndent(2) + "con = getCon();");
        source.add("");
        source.add(GenUtil.getIndent(2) + "try {");
        source.add(GenUtil.getIndent(2) + "    //SQL");
        source.add(GenUtil.getIndent(2) + "    SqlBuffer sql = new SqlBuffer();");

        //SQL
        List sql = sqlGen__.generateDeleteSqlList();
        Iterator it = sql.iterator();
        while (it.hasNext()) {
            //
            String line = (String) it.next();
            line = GenUtil.escapeSrc(line);
            source.add(GenUtil.getIndent(3) + "sql.addSql(\"" + line + "\");");
        }
        source.add("");
        source.add(GenUtil.getIndent(3) + "pstmt = con.prepareStatement(sql.toSqlString());");

        //PrimaryKey
        paramIt = params.iterator();
        while (paramIt.hasNext()) {
            pcnt++;
            JavaParamModel model = (JavaParamModel) paramIt.next();
            String mnameSetter = "sql.addValue";
            // R[hZbgBEAN擾郁\bh
            mnameSetter += "(" + model.getParamName() + ");";
            //
            source.add(GenUtil.getIndent(3) + mnameSetter);
        }
        source.add("");
        source.add(GenUtil.getIndent(2) + "    log__.info(sql.toLogString());");
        source.add(GenUtil.getIndent(2) + "    sql.setParameter(pstmt);");
        source.add(GenUtil.getIndent(2) + "    count = pstmt.executeUpdate();");
        source.add(GenUtil.getIndent(2) + "} catch (SQLException e) {");
        source.add(GenUtil.getIndent(2) + "    throw e;");
        source.add(GenUtil.getIndent(2) + "} finally {");
        source.add(GenUtil.getIndent(2) + "    JDBCUtil.closeStatement(pstmt);");
        source.add(GenUtil.getIndent(2) + "}");
        source.add(GenUtil.getIndent(2) + "return count;");
        source.add(GenConst.INDENT + "}");
        source.add("");
        return source;
    }

    /**
     * <p>SelectŎgp錋ʃZbgBEAN𐶐郁\bh𐶐܂B
     * @param source \[X
     * @return \[X
     */
    public ArrayList __createSelectBeanFromRs(ArrayList<String> source) {
        //e[u
        String tblName = table__.getName();
        //BEAN
        String bean = __createModelClassName(tblName);
        //R[hZbgBEAN擾郁\bh
        String mnameRs =
            GenUtil.createResultsetGetterName(
                tblName,
                TypeMappingResourceBundle.getString("table_prefix"));

        source.add(GenConst.INDENT + "/**");
        source.add(
            GenConst.INDENT + " * <p>Create " + tblName + " Data Bindding JavaBean From ResultSet");
        source.add(GenConst.INDENT + " * @param rs ResultSet");
        source.add(GenConst.INDENT + " * @return created " + bean);
        source.add(GenConst.INDENT + " * @throws SQLException SQLsO");
        source.add(GenConst.INDENT + " */");
        source.add(
            GenConst.INDENT
                + "private "
                + bean
                + " "
                + mnameRs
                + "(ResultSet rs) throws SQLException {");
        source.add(GenUtil.getIndent(2) + bean + " bean = new " + bean + "();");

        //lZbg
        ArrayList cols = table__.getColumns();
        Iterator it = cols.iterator();
        while (it.hasNext()) {
            Column col = (Column) it.next();
            //beanSET\bh擾
            String colName = col.getName();
            String smethodName = GenUtil.createMethodName(false, colName);

            //ResultSet̎擾\bh
            String gmethodName = GenUtil.getGetMethodNameFromRs(col.getType());
            String rep = "rs." + gmethodName + "(\"" + col.getName() + "\")";

            //^ϊp\bh擾
            String castMethod = GenUtil.getGetTypeCastMethodName(col.getType(), rep);
            if (castMethod == null) {
                source.add(GenUtil.getIndent(2) + "bean." + smethodName + "(" + rep + ");");
            } else {
                source.add(GenUtil.getIndent(2) + "bean." + smethodName + "(" + castMethod + ");");
            }
        }
        source.add(GenUtil.getIndent(2) + "return bean;");
        source.add(GenConst.INDENT + "}");
        return null;
    }
    /**
     * @return packageName ߂܂B
     */
    public String getPackageName() {
        return packageName__;
    }
    /**
     * @param packageName packageName ݒB
     */
    public void setPackageName(String packageName) {
        packageName__ = packageName;
    }

    /**
     * <br>
     * [@ \] fpbP[W擾B<br>
     * [ ] <br>
     * [ l]
     * @return pbP[W
     */
    public String getModelPackageName() {
        return modelPackageName__;
    }

    /**
     * <br>
     * [@ \] fNX̃pbP[WԂ<br>
     * [ ] <br>
     * [ l]
     * @param modelPackageName pbP[W
     */
    public void setModelPackageName(String modelPackageName) {
        modelPackageName__ = modelPackageName;
    }

    /**
     * <br>
     * [@ \] daoClassNameFlgԂB<br>
     * [ ] <br>
     * [ l]
     * @return daoClassNameFlg
     */
    public boolean isDaoClassNameFlg() {
        return daoClassNameFlg__;
    }

    /**
     * <br>
     * [@ \] daoClassNameFlgZbgB<br>
     * [ ] <br>
     * [ l]
     * @param daoClassNameFlg daoClassNameFlg
     */
    public void setDaoClassNameFlg(boolean daoClassNameFlg) {
        this.daoClassNameFlg__ = daoClassNameFlg;
    }

    /**
     * <br>
     * [@ \] modelClassNameFlg__Ԃ<br>
     * [ ] <br>
     * [ l]
     * @return modelClassNameFlg
     */
    public boolean isModelClassNameFlg() {
        return modelClassNameFlg__;
    }

    /**
     * <br>
     * [@ \] modelClassNameFlgZbgB<br>
     * [ ] <br>
     * [ l]
     * @param modelClassNameFlg modelClassNameFlg
     */
    public void setModelClassNameFlg(boolean modelClassNameFlg) {
        this.modelClassNameFlg__ = modelClassNameFlg;
    }
}
