/*
 * create   : 2004/07/30
 * modified :
 */
package jp.groupsession.v2.dba.core;

import java.sql.Types;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import jp.co.sjts.util.StringUtil;
import jp.groupsession.v2.dba.meta.Column;
import jp.groupsession.v2.dba.meta.Table;

/**
 * <br>[@  \] ftHgSQL Generator
 * <br>[  ] DBiɍ쐬ꍇ́ÃNXp\bhI[o[ChĎgpB
 * <br>[  l]
 * @author JTS
 */
public class SqlGeneratorDefault extends AbstractSqlGenerator {
    /** Logging CX^X */
    private static Log log__ = LogFactory.getLog(SqlGeneratorDefault.class);

    /**
     * <p>ftHgRXgN^
     */
    public SqlGeneratorDefault() {
    }

    /**
     * <p>e[uZbg܂
     * @param table e[u
     */
    public SqlGeneratorDefault(Table table) {
        super(table);
    }

    /**
     * <p>e[u񂩂CreateTable쐬܂B(String)
     * @return Createtable
     */
    public String generateCreateTableSql() {
        return StringUtil.toStringByList(generateCreateTableSqlList());
    }

    /**
     * <p>e[u񂩂CreateTable쐬܂B(List)
     * @return Createtable
     */
    public List generateCreateTableSqlList() {
        ArrayList<String> sql = new ArrayList<String>();

        String tblName = table_.getName();

        log__.debug("-- table is " + tblName +  "--");

        sql.add(" create table " + tblName + " (");

        //PrimaryKey
        ArrayList keys = table_.getPkey();

        //
        ArrayList cols = table_.getColumns();
        Iterator it = cols.iterator();
        while (it.hasNext()) {
            Column col = (Column) it.next();
            //Java^
            int type = col.getType();
            String typeStr = __getTypeStr(col);

            //
            String line = " " + GenConst.INDENT_SQL + col.getName() + " " + typeStr;
            if (it.hasNext() || !keys.isEmpty()) {
                line += ",";
            }
            sql.add(line);
        }

        //L[̐ݒ
        if (!keys.isEmpty()) {
            String keystr = "";
            Iterator it2 = keys.iterator();
            while (it2.hasNext()) {
                Column col = (Column) it2.next();
                keystr += col.getName();
                if (it2.hasNext()) {
                    keystr += ",";
                }
            }
            sql.add(GenConst.INDENT_SQL + " primary key (" + keystr + ")");
        }
        sql.add(" )");
        return sql;
    }

    /**
     * <p>񂩂Createtablep̗^Cv𐶐܂B
     * @param col 
     * @return ^Cv
     */
    private String __getTypeStr(Column col) {
        String ret = null;
        int type = col.getType();
        int size = col.getSize();

        switch (type) {
            case Types.ARRAY :
                log__.debug("ARRAY");
            case Types.BIGINT :
                log__.debug("BIGINT");
            case Types.BINARY :
                log__.debug("BINARY");
            case Types.BIT :
                log__.debug("BIT");
            case Types.BLOB :
                log__.debug("BLOB");
            case Types.BOOLEAN :
                log__.debug("BOOLEAN");
            case Types.CHAR :
                log__.debug("CHAR");
            case Types.CLOB :
                log__.debug("CLOB");
            case Types.DATALINK :
                log__.debug("DATALINK");
            case Types.DATE :
                ret = "Date";
                log__.debug("DATE");
                break;

            case Types.DECIMAL :
                log__.debug(Types.DECIMAL + "DECIMAL");
            case Types.DISTINCT :
                log__.debug(Types.DISTINCT + " DISTINCT");
            case Types.DOUBLE :
                log__.debug(Types.DOUBLE + " DOUBLE");
            case Types.FLOAT :
                log__.debug(Types.FLOAT + " FLOAT");
            case Types.INTEGER : //3
                log__.debug(Types.INTEGER + " INTEGER");
                ret = "NUMBER(" + col.getSize() + "," + col.getDigits() + ")";
                break;

            case Types.JAVA_OBJECT :
                log__.debug("JAVA_OBJECT");
            case Types.LONGVARBINARY :
                log__.debug("LONGVARBINARY");
            case Types.LONGVARCHAR :
                log__.debug("LONGVARCHAR");
            case Types.NULL :
                log__.debug("NULL");
            case Types.NUMERIC :
                log__.debug("NUMERIC");
            case Types.OTHER :
                log__.debug("OTHER");
            case Types.REAL :
                log__.debug("REAL");
            case Types.REF :
                log__.debug("REF");
            case Types.SMALLINT :
                log__.debug("SMALLINT");
            case Types.STRUCT :
                log__.debug("STRUCT");
            case Types.TIME :
                log__.debug("TIME");
            case Types.TIMESTAMP :
                log__.debug("TIMESTAMP");
            case Types.TINYINT :
                log__.debug("TINYINT");
            case Types.VARBINARY :
                log__.debug("VARBINARY");
            case Types.VARCHAR :
                log__.debug("VARCHAR");
                ret = "varchar(" + size + ")";
                break;
            default :
                log__.debug("UNKNOWN");
                ret = "UNKNOWN";
        }

        //Not Null
        String notNull = "";
        if (java.sql.DatabaseMetaData.columnNoNulls == col.getNullable()) {
            notNull = " not null";
        }
        ret += notNull;

        log__.debug(col.getName() + " type = " + ret + "| " + col.getType());
        log__.debug(col.getName() + " size = " + size);

        return ret;
    }

    /**
     * <p>e[u񂩂CreateTable쐬܂B
     * @return Createtable
     */
    public String generateDropTableSql() {
        return StringUtil.toStringByList(generateDropTableSqlList());
    }

    /**
     * <p>e[u񂩂CreateTable쐬܂B
     * @return Createtable
     */
    public List generateDropTableSqlList() {
        ArrayList<String> sql = new ArrayList<String>();
        //e[u
        String tblName = table_.getName();
        sql.add("drop table " + tblName);
        return sql;
    }

    /**
     * <p>e[u񂩂select쐬܂B
     * @return select
     */
    public String generateSelectSql() {
        return StringUtil.toStringByList(generateSelectSqlList());
    }

    /**
     * <p>e[u񂩂select쐬܂B
     * @return select
     */
    public String generateSelectAllSql() {
        return StringUtil.toStringByList(generateSelectSqlAllList());
    }

    /**
     * <p>e[u񂩂select쐬܂B
     * @return Xg`select
     */
    public List generateSelectSqlAllList() {
        ArrayList<String> sql = new ArrayList<String>();
        //e[u
        String tblName = table_.getName();
        sql.add(" select ");

        ArrayList cols = table_.getColumns();
        Iterator it = cols.iterator();
        while (it.hasNext()) {
            Column col = (Column) it.next();
            //
            String line = " " + GenConst.INDENT_SQL + col.getName();
            if (it.hasNext()) {
                line += ",";
            }
            sql.add(line);
        }
        sql.add(" from ");
        sql.add(" " + GenConst.INDENT_SQL + tblName);
        return sql;
    }

    /**
     * <p>e[u񂩂select쐬܂B
     * @return select
     */
    public List generateSelectSqlList() {
        ArrayList<String> sql = new ArrayList<String>();
        //e[u
        String tblName = table_.getName();
        sql.add(" select");

        ArrayList cols = table_.getColumns();
        Iterator it = cols.iterator();
        while (it.hasNext()) {
            Column col = (Column) it.next();
            //
            String line = " " + GenConst.INDENT_SQL + col.getName();
            if (it.hasNext()) {
                line += ",";
            }
            sql.add(line);
        }
        sql.add(" from");
        sql.add(" " + GenConst.INDENT_SQL + tblName);

        //L[̏ǉ
        //PrimaryKey
        ArrayList keys = table_.getPkey();
        if (!keys.isEmpty()) {
            sql.add(" where ");
            Iterator it2 = keys.iterator();
            while (it2.hasNext()) {
                Column col = (Column) it2.next();
                String colName = col.getName();
                sql.add(" " + GenConst.INDENT_SQL + colName + "=?");
                if (it2.hasNext()) {
                    sql.add(" " + "and");
                }
            }
        }

        return sql;
    }

    /**
     * <p>e[u񂩂Insert쐬܂B
     * @return insert
     */
    public String generateInsertSql() {
        return StringUtil.toStringByList(generateInsertSqlList());
    }

    /**
     * <p>e[u񂩂Insert쐬܂B
     * @return Xg`insert
     */
    public List generateInsertSqlList() {
        ArrayList<String> sql = new ArrayList<String>();
        //e[u
        String tblName = table_.getName();
        sql.add(" insert ");
        sql.add(" into ");
        sql.add(" " + tblName + "(");

        ArrayList cols = table_.getColumns();
        Iterator it = cols.iterator();
        while (it.hasNext()) {
            Column col = (Column) it.next();
            //
            String line = " " + GenConst.INDENT_SQL + col.getName();
            if (it.hasNext()) {
                line += ",";
            }
            sql.add(line);
        }
        sql.add(" )");
        sql.add(" values");
        sql.add(" (");

        //l
        Iterator it2 = cols.iterator();
        while (it2.hasNext()) {
            it2.next();
            String line = " " + GenConst.INDENT_SQL;
            if (it2.hasNext()) {
                line += "?,";
            } else {
                line += "?";
            }
            sql.add(line);
        }
        sql.add(" )");
        return sql;
    }

    /**
     * <p>e[u񂩂Update쐬܂B
     * @return update
     */
    public String generateUpdateSql() {
        return StringUtil.toStringByList(generateUpdateSqlList());
    }

    /**
     * <p>e[u񂩂Update쐬܂B
     * @return update
     */
    public List generateUpdateSqlList() {
        ArrayList<String> sql = new ArrayList<String>();
        //e[u
        String tblName = table_.getName();
        sql.add(" update");
        sql.add(" " + GenConst.INDENT_SQL + tblName + "");
        sql.add(" set ");

        ArrayList cols = table_.getColumns();
        Iterator it = cols.iterator();
        while (it.hasNext()) {
            Column col = (Column) it.next();
            if (col.getSeqKey() > 0) {
                continue;
            }
            //
            String line = " " + GenConst.INDENT_SQL + col.getName() + "=?";
            if (it.hasNext()) {
                line += ",";
            }
            sql.add(line);
        }

        //PrimaryKey
        ArrayList keys = table_.getPkey();
        if (!keys.isEmpty()) {
            //L[̏ǉ
            sql.add(" where ");
            Iterator it2 = keys.iterator();
            while (it2.hasNext()) {
                Column col = (Column) it2.next();
                String colName = col.getName();
                sql.add(" " + GenConst.INDENT_SQL + colName + "=?");
                if (it2.hasNext()) {
                    sql.add(" and");
                }
            }
        }
        return sql;
    }

    /**
     * <p>e[u񂩂delete쐬܂B
     * @return delete
     */
    public String generateDeleteSql() {
        return StringUtil.toStringByList(generateDeleteSqlList());
    }

    /**
     * <p>e[u񂩂Delete쐬܂B
     * @return delete
     */
    public List generateDeleteSqlList() {
        ArrayList<String> sql = new ArrayList<String>();
        //e[u
        String tblName = table_.getName();
        sql.add(" delete");
        sql.add(" from");
        sql.add(" " + GenConst.INDENT_SQL + tblName);

        //L[̏ǉ
        //PrimaryKey
        ArrayList keys = table_.getPkey();
        if (!keys.isEmpty()) {
            sql.add(" where ");
            Iterator it2 = keys.iterator();
            while (it2.hasNext()) {
                Column col = (Column) it2.next();
                String colName = col.getName();
                sql.add(" " + GenConst.INDENT_SQL + colName + "=?");
                if (it2.hasNext()) {
                    sql.add(" " + "and");
                }
            }
        }
        return sql;
    }
}
