package jp.groupsession.v2.dba.core;

import jp.groupsession.v2.dba.gen.DbProduct;
import jp.groupsession.v2.dba.meta.Table;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * <br>[@  \] SqlGenerator𐶐E擾܂B
 * <br>[  ]
 * <br>[  l]
 *
 * @author JTS
 */
public class SqlGeneratorFactory {
    /** Logging CX^X */
    private static Log log__ = LogFactory.getLog(SqlGeneratorFactory.class);

    /**
     * <p>XDBiɑΉSqlGeneratorԂ܂B
     * 擾łȂꍇClassNotFoundExceptionX[܂
     * @param product i
     * @param tbl e[uIuWFNg
     * @return XDBiɑΉCreateTableFileGenerator
     */
    public static AbstractSqlGenerator getSqlGenerator(String product, Table tbl) {

        AbstractSqlGenerator sqlGen = null;
        product = product.toUpperCase();
        log__.debug("DB Products is " + product);

        if (DbProduct.ORACLE.equals(product)) {
            //Oracle
            sqlGen = new SqlGeneratorOracle(tbl);
        } else if (DbProduct.POSTGRESQL.equals(product)) {
            //PostgreSQL
            sqlGen = new SqlGeneratorPgsql(tbl);
        } else if (DbProduct.H2.equals(product)) {
            //H2
            sqlGen = new SqlGeneratorH2(tbl);
        } else {
            //Default
            sqlGen = new SqlGeneratorDefault(tbl);
        }
        return sqlGen;
    }
}
