package jp.groupsession.v2.dba.dba001;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import jp.co.sjts.util.Encoding;
import jp.co.sjts.util.NullDefault;
import jp.co.sjts.util.StringUtil;
import jp.co.sjts.util.archive.ZipUtil;
import jp.co.sjts.util.http.TempFileUtil;
import jp.co.sjts.util.io.IOTools;
import jp.co.sjts.util.jdbc.JDBCUtil;
import jp.groupsession.v2.dba.AbstractDbaAction;
import jp.groupsession.v2.dba.GSConstDba;
import jp.groupsession.v2.dba.core.AbstractSqlGenerator;
import jp.groupsession.v2.dba.core.SqlGeneratorFactory;
import jp.groupsession.v2.dba.dba001.dao.Dba001Dao;
import jp.groupsession.v2.dba.gen.DaoBeanGenerator;
import jp.groupsession.v2.dba.gen.GenerateException;
import jp.groupsession.v2.dba.meta.JdbcMetaExplorer;
import jp.groupsession.v2.dba.meta.JdbcMetaUtil;
import jp.groupsession.v2.dba.meta.Table;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * <br>[@  \] DBA001
 * <br>[  ]
 * <br>[  l]
 *
 * @author JTS
 */
public class Dba001Action extends AbstractDbaAction {

    /** Logging CX^X */
    private static Log log__ = LogFactory.getLog(Dba001Action.class);

    /**
     * <br>[@  \] ANVs
     * <br>[  ]
     * <br>[  l]
     * @param map ActionMapping
     * @param form ActionForm
     * @param req HttpServletRequest
     * @param res HttpServletResponse
     * @param con DB Connection
     * @return ActionForward
     * @throws Exception sO
     * @see jp.co.sjts.util.struts.AbstractAction
     * @see #executeAction(org.apache.struts.action.ActionMapping,
     *                      org.apache.struts.action.ActionForm,
     *                      javax.servlet.http.HttpServletRequest,
     *                      javax.servlet.http.HttpServletResponse,
     *                      java.sql.Connection)
     */
    public ActionForward executeAction(ActionMapping map, ActionForm form,
            HttpServletRequest req, HttpServletResponse res, Connection con)
            throws Exception {

        ActionForward forward = null;
        //R}hp[^擾
        String cmd = NullDefault.getString(req.getParameter("CMD"), "");
        cmd = cmd.trim();
        log__.debug("CMD==>" + cmd);

        //Form
        Dba001Form dbaform = (Dba001Form) form;
        dbaform.setResultMessage("");

        if (cmd.equals("001_ok")) {
            //SQLs
            String sql = dbaform.getDba001SqlString();
            doSql(sql, con, dbaform);
            forward = map.getInputForward();
        } else if (cmd.equals("001_gen")) {
            // Generate Dao and Model
            log__.debug("Generate Dao and Model");
            doGenerateDaoModel(req, res, con, dbaform);
            forward = null;
        } else {
            //\
            forward = map.getInputForward();
        }

        createDbInfo(dbaform, con);
        return forward;
    }

    /**
     * <br>[@  \] ͂ꂽSQLsB
     * <br>[  ]
     * <br>[  l]
     * @param sql SQL
     * @param con DBRlNV
     * @param dbaform tH[
     * @throws SQLException SQLsO
     */
    private void doSql(String sql, Connection con, Dba001Form dbaform) throws SQLException {
        PreparedStatement pstmt = null;
        ResultSet rs = null;
        int count = 0;
        //DBe[u擾
        JdbcMetaExplorer jmeta = new JdbcMetaExplorer(con);

        //
        dbaform.setDba001ExeType(null);
        if (sql == null) {
            return;
        }

        //s^Cv菈 ɏCĂr
        sql = sql.trim();
        String tmp = sql.toLowerCase();

        log__.info(sql);
        pstmt = con.prepareStatement(sql);

        //
        if (tmp.startsWith("select")) {
            //SELECTs
            try {
                rs = pstmt.executeQuery();
                //
                ArrayList<String> headerNameList = jmeta.getResultsetHeader(rs);
                dbaform.setDba001ResultHeaderName(headerNameList);
                //擾
                ArrayList<ArrayList> rows = new ArrayList<ArrayList>();
                while (rs.next()) {
                    //
                    ArrayList<String> row = new ArrayList<String>();
                    rows.add(row);
                    for (String hname : headerNameList) {
                        String data = rs.getString(hname);
                        if (data == null) {
                            data = "[NULL]";
                        }
                        row.add(data);
                    }
                }
                dbaform.setDba001ResultData(rows);
                //s^CvZbg
                dbaform.setDba001ExeType(GSConstDba.SQLEXE_TYPE_SELECT);
            } catch (SQLException e) {
                throw e;
            } finally {
                JDBCUtil.closeResultSet(rs);
            }
        } else {
            //UPDATE or INSERT s
            try {
                count = pstmt.executeUpdate();
                con.commit();
            } catch (SQLException e) {
                throw e;
            }
            //s
            dbaform.setDba001ExeType(GSConstDba.SQLEXE_TYPE_UPDATE);
            String message = count + "XV܂B";
            dbaform.setResultMessage(message);
        }
        log__.debug("SQLs");
    }

    /**
     * <br>[@  \] ʂɕ\DB쐬B
     * <br>[  ]
     * <br>[  l]
     * @param dbaform tH[
     * @param con RlNV
     * @throws SQLException SQLsO
     */
    public void createDbInfo(Dba001Form dbaform, Connection con) throws SQLException {

        //DBe[u擾
        JdbcMetaExplorer jmeta = new JdbcMetaExplorer(con);

        String product = JdbcMetaUtil.getDbProductName(con);
        //
        List<Table> tables = jmeta.getTables("TABLE");
        ArrayList<TableInfoModel> tinfoes = new ArrayList<TableInfoModel>();
        //\pe[u̍쐬
        for (Table table : tables) {
            TableInfoModel tinfo = new TableInfoModel();
            tinfo.setTable(table);
            AbstractSqlGenerator sqlGenerator = SqlGeneratorFactory.getSqlGenerator(product, table);
            //select
            tinfo.setSqlSelectString(sqlGenerator.generateSelectSql());
            //update
            tinfo.setSqlUpdateString(sqlGenerator.generateUpdateSql());
            //insert
            tinfo.setSqlInsertString(sqlGenerator.generateInsertSql());
            //delete
            tinfo.setSqlDeleteString(sqlGenerator.generateDeleteSql());
            //
            tinfoes.add(tinfo);
        }

        List<Table> views = jmeta.getTables("VIEW");
        ArrayList<ViewInfoModel> vinfoes = new ArrayList<ViewInfoModel>();
        //\pr[̍쐬
        for (Table table : views) {
            ViewInfoModel tinfo = new ViewInfoModel();
            tinfo.setTable(table);
            AbstractSqlGenerator sqlGenerator = SqlGeneratorFactory.getSqlGenerator(product, table);
            //select
            tinfo.setSqlSelectString(sqlGenerator.generateSelectSql());
            //
            vinfoes.add(tinfo);
        }

        //e[uZbg
        dbaform.setDba001TableInfos(tinfoes);           //TABLE
        dbaform.setDba001ViewInfos(vinfoes);            //VIEW

        Dba001Dao dao = new Dba001Dao(con);
        dbaform.setDba001SeqInfos(dao.getSequenses());  //SEQUENCE
    }

    /**
     * <br>[@  \] Dao,Model𐶐AzipkA_E[hsB
     * <br>[  ]
     * <br>[  l]
     * @param req HttpServletRequest
     * @param res HttpServletResponse
     * @param con DBRlNV
     * @param dbaform tH[
     * @throws SQLException SQLsO
     * @throws Exception \s\ȗO
     */
    private void doGenerateDaoModel(HttpServletRequest req,
            HttpServletResponse res, Connection con, Dba001Form dbaform)
            throws SQLException, Exception {

        String tableName = dbaform.getDba001GenTableName();
        log__.debug("TABLE NAME = " + tableName);
        if (StringUtil.isNullZeroString(tableName)) {
            //Ȃ
            return;
        }
        //DBe[u擾
        JdbcMetaExplorer jmeta = new JdbcMetaExplorer(con);
        Table table = jmeta.getTable(tableName);

        //e|fBNg擾
        HttpSession session = req.getSession();
        String sessionId = session.getId();
        String tempDir = __getTempDir(sessionId, tableName);
        IOTools.isDirCheck(tempDir, true);

        //Dao and Model
        String product = JdbcMetaUtil.getDbProductName(con);
        DaoBeanGenerator gen = new DaoBeanGenerator(product);
        try {
            gen.generate(table, tempDir, Encoding.WINDOWS_31J);
        } catch (GenerateException e) {
            e.printStackTrace();
            log__.error(e);
        }

        //t@Ck
        String fpath = __getZipFilePath(sessionId, tableName);
        ZipUtil.zipDir("Windows-31J", tempDir, fpath);

        //_E[h
        //_E[ht@C̍쐬
        String tempZipFile = __getTempDir2(sessionId, tableName);
        log__.debug("tempZipFile = " + tempZipFile);
        TempFileUtil.downloadAtachment(req, res, tempZipFile, tableName + ".zip",
                                    Encoding.UTF_8);
    }
    /**
     * HelloWorldp̓YtfBNg擾
     * [@  \]
     * [  ]
     * [  l]
     * @param sessionId ZbVID
     * @param tableName e[u
     * @return String fBNgPATH
     */
    private String __getTempDir(String sessionId, String tableName) {

        //ꎞYtfBNgRootpX擾
        String tempRootDir = getTempPath();

        //Cӂ̃fBNg𐮌`
        StringBuffer buf = new StringBuffer("");
        buf.append(tempRootDir);
        buf.append("/");
        buf.append(GSConstDba.PLUGIN_ID_DBA);
        buf.append("/");
        buf.append(sessionId);
        buf.append("/");
        buf.append(tableName);
        buf.append("/");
        return IOTools.replaceFileSep(buf.toString());
    }
    /**
     * HelloWorldp̓YtfBNg擾
     * [@  \]
     * [  ]
     * [  l]
     * @param sessionId ZbVID
     * @param tableName e[u
     * @return String fBNgPATH
     */
    private String __getTempDir2(String sessionId, String tableName) {

        //ꎞYtfBNgRootpX擾
        String tempRootDir = getTempPath();

        //Cӂ̃fBNg𐮌`
        StringBuffer buf = new StringBuffer("");
        buf.append(tempRootDir);
        buf.append("/");
        buf.append(GSConstDba.PLUGIN_ID_DBA);
        buf.append("/");
        buf.append(sessionId);
        buf.append("/");
        buf.append(tableName);
        buf.append(".zip");
        return IOTools.replaceFileSep(buf.toString());
    }
    /**
     * HelloWorldp̓YtfBNg擾
     * [@  \]
     * [  ]
     * [  l]
     * @param sessionId ZbVID
     * @param tableName e[u
     * @return String fBNgPATH
     */
    private String __getZipFilePath(String sessionId, String tableName) {

        //ꎞYtfBNgRootpX擾
        String tempRootDir = getTempPath();

        //Cӂ̃fBNg𐮌`
        StringBuffer buf = new StringBuffer("");
        buf.append(tempRootDir);
        buf.append("/");
        buf.append(GSConstDba.PLUGIN_ID_DBA);
        buf.append("/");
        buf.append(sessionId);
        buf.append("/");
        buf.append(tableName);
        buf.append(".zip");
        return IOTools.replaceFileSep(buf.toString());
    }
}
