package jp.groupsession.v2.dba.dba001.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import jp.co.sjts.util.dao.AbstractDao;
import jp.co.sjts.util.jdbc.JDBCUtil;
import jp.co.sjts.util.jdbc.SqlBuffer;
import jp.groupsession.v2.dba.dba001.model.Dba001Model;


/**
 * <br>[@  \] DBADaoNX
 * <br>[  ]
 * <br>[  l]
 *
 * @author JTS
 */
public class Dba001Dao extends AbstractDao {

    /** Logging CX^X */
    private static Log log__ = LogFactory.getLog(Dba001Dao.class);

    /**
     * <p>Set Connection
     * @param con Connection
     */
    public Dba001Dao(Connection con) {
        super(con);
    }



    /**
     * <br>[@  \] V[PXS擾
     * <br>[  ]
     * <br>[  l]
     * @return V[PXꗗ
     * @throws SQLException SQLsO
     */
    public ArrayList<Dba001Model> getSequenses()
    throws SQLException {

        PreparedStatement pstmt = null;
        ResultSet rs = null;
        Connection con = null;
        ArrayList<Dba001Model> ret = new ArrayList<Dba001Model>();
        con = getCon();

        try {
            //SQL
            SqlBuffer sql = new SqlBuffer();
            sql.addSql(" select");
            sql.addSql("   INFORMATION_SCHEMA.SEQUENCES.SEQUENCE_CATALOG as CATALOG,");
            sql.addSql("   INFORMATION_SCHEMA.SEQUENCES.SEQUENCE_SCHEMA as SCHEMA,");
            sql.addSql("   INFORMATION_SCHEMA.SEQUENCES.SEQUENCE_NAME as NAME,");
            sql.addSql("   INFORMATION_SCHEMA.SEQUENCES.CURRENT_VALUE as VALUE,");
            sql.addSql("   INFORMATION_SCHEMA.SEQUENCES.INCREMENT as INCREMENT,");
            sql.addSql("   INFORMATION_SCHEMA.SEQUENCES.IS_GENERATED as GENERATED,");
            sql.addSql("   INFORMATION_SCHEMA.SEQUENCES.REMARKS as REMARKS,");
            sql.addSql("   INFORMATION_SCHEMA.SEQUENCES.CACHE as CACHE,");
            sql.addSql("   INFORMATION_SCHEMA.SEQUENCES.ID as ID");
            sql.addSql(" from");
            sql.addSql(" INFORMATION_SCHEMA.SEQUENCES");

            pstmt = con.prepareStatement(sql.toSqlString());

            log__.info(sql.toLogString());

            sql.setParameter(pstmt);
            rs = pstmt.executeQuery();
            while (rs.next()) {
                Dba001Model mdl = new Dba001Model();

                mdl.setDbaCatalog(rs.getString("CATALOG"));
                mdl.setDbaSchema(rs.getString("SCHEMA"));
                mdl.setDbaName(rs.getString("NAME"));
                mdl.setDbaValue(rs.getInt("VALUE"));
                mdl.setDbaIncrement(rs.getInt("INCREMENT"));
                mdl.setDbaGenerated(rs.getBoolean("GENERATED"));
                mdl.setDbaRemarks(rs.getString("REMARKS"));
                mdl.setDbaCache(rs.getInt("CACHE"));
                mdl.setDbaId(rs.getInt("ID"));

                ret.add(mdl);
            }

        } catch (SQLException e) {
            throw e;
        } finally {
            JDBCUtil.closeResultSet(rs);
            JDBCUtil.closeStatement(pstmt);
        }

        return ret;
    }
}
