/*
 * create   : 2004/08/04
 * modified :
 */
package jp.groupsession.v2.dba.gen;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.Iterator;
import java.util.List;

import jp.co.sjts.util.Encoding;
import jp.co.sjts.util.io.IOTools;
import jp.groupsession.v2.dba.core.AbstractSqlGenerator;
import jp.groupsession.v2.dba.core.SqlGeneratorFactory;
import jp.groupsession.v2.dba.core.TypeMappingResourceBundle;
import jp.groupsession.v2.dba.meta.JdbcMetaExplorer;
import jp.groupsession.v2.dba.meta.Table;

/**
 * <br>[@  \] CreateTableSQLԂ܂
 * <br>[  ]
 * <br>[  l]
 * @author JTS
 */
public class CreateTableFileGenerator extends AbstractGenerator {

    /** t@C̊gq */
    private static final String EXTENSION__ = ".sql";
    /** i */
    private String product__ = null;

    /**
     * <p>̃RXgN^
     */
    public CreateTableFileGenerator() {
    }

    /**
     * <p>̃RXgN^
     * @param product i
     */
    public CreateTableFileGenerator(String product) {
        product__ = product;
    }

    /**
     * <p>CreateTablẽt@C쐬܂B
     * @param tables e[u
     * @throws GenerateException ɎsꍇɃX[
     */
    public void generate(List tables) throws GenerateException {

        try {
            Iterator it = tables.iterator();
            while (it.hasNext()) {
                //e[u
                Table tbl = (Table) it.next();

                //e[u
                String tblName = tbl.getName();

                //SQLIuWFNg̍쐬
                AbstractSqlGenerator sqlGen = SqlGeneratorFactory.getSqlGenerator(product__, tbl);

                //t@CɃCg
                IOTools.writeText(
                    TypeMappingResourceBundle.getString("destdir"),
                    tblName + EXTENSION__,
                    Encoding.WINDOWS_31J,
                    sqlGen.generateCreateTableSql());
            }
        } catch (IOException e) {
            throw new GenerateException(e);
        }
    }

    /**
     * <p>CreateTablẽt@C쐬܂B
     * @param con RlNV
     * @throws GenerateException ɎsꍇɃX[
     */
    public void generate(Connection con) throws GenerateException {
        try {
            //RlNVDBe擾EmF
            JdbcMetaExplorer jexp = new JdbcMetaExplorer(con);
            List tables = jexp.getTables("TABLE");
            generate(tables);
        } catch (SQLException e) {
            throw new GenerateException(e);
        }
    }
}
