/*
 * create   : 2004/08/04
 * modified :
 */
package jp.groupsession.v2.dba.gen;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.Iterator;
import java.util.List;

import jp.co.sjts.util.Encoding;
import jp.co.sjts.util.io.IOTools;
import jp.groupsession.v2.dba.core.AbstractSqlGenerator;
import jp.groupsession.v2.dba.core.BeanGenerator;
import jp.groupsession.v2.dba.core.DaoGenerator;
import jp.groupsession.v2.dba.core.GenUtil;
import jp.groupsession.v2.dba.core.SqlGeneratorFactory;
import jp.groupsession.v2.dba.core.TypeMappingResourceBundle;
import jp.groupsession.v2.dba.meta.JdbcMetaExplorer;
import jp.groupsession.v2.dba.meta.Table;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * <p>DaoBean𐶐NX
 * @author JTS
 */
public class DaoBeanGenerator extends AbstractGenerator {
    /** Logging CX^X */
    private static Log log__ = LogFactory.getLog(DaoBeanGenerator.class);

    /** t@C̊gq */
    private static final String EXTENSION__ = ".java";
    /** i */
    private String product__ = null;

    /**
     * <p>̃RXgN^
     */
    public DaoBeanGenerator() {
    }

    /**
     * <p>̃RXgN^
     * @param product i
     */
    public DaoBeanGenerator(String product) {
        product__ = product;
    }

    /**
     * <p>e[uf[^̃XgCreateTableSQL𐶐܂B
     * @param tables e[u
     * @throws GenerateException ̃G[
     */
    public void generate(List tables) throws GenerateException {

        try {
            Iterator it = tables.iterator();
            while (it.hasNext()) {
                //
                Table tbl = (Table) it.next();
                generate(tbl, TypeMappingResourceBundle.getString("destdir"), Encoding.WINDOWS_31J);
            }
        } catch (Exception e) {
            log__.error(e);
            throw new GenerateException();
        }
    }

    /**
     * <p>e[uf[^CreateTableSQL𐶐܂B
     * @param tbl e[u
     * @param destDir o͐
     * @param encode o͕R[h
     * @throws GenerateException ̃G[
     */
    public void generate(Table tbl, String destDir, String encode) throws GenerateException {
        String tblName = tbl.getName();

        try {
            // Bean Class
            String beanClsName = GenUtil.createClassName(tblName, false,
                    TypeMappingResourceBundle.getString("table_prefix"));

            // Dao Class
            String daoClsName = GenUtil.createClassName(tblName, true,
                    TypeMappingResourceBundle.getString("table_prefix"));

            // SQLIuWFNg̍쐬
            AbstractSqlGenerator sqlGen = getSqlGenerator(product__, tbl);

            // JavaBean𐶐
            BeanGenerator bg = new BeanGenerator(tbl);
            IOTools.writeText(destDir, beanClsName + EXTENSION__, encode, bg
                    .generate());
            // Dao𐶐
            DaoGenerator dg = new DaoGenerator(tbl, sqlGen);
            IOTools.writeText(destDir, daoClsName + EXTENSION__, encode, dg
                    .generate());
        } catch (Exception e) {
            log__.error(e);
            throw new GenerateException();
        }
    }

    /**
     * <p>
     * RlNVCreateTableSQLt@C𐶐܂B(String)
     *
     * @param con
     *            RlNV
     * @throws GenerateException
     *             G[
     */
    public void generate(Connection con) throws GenerateException {
        try {
            //RlNVDBe擾EmF
            JdbcMetaExplorer jexp = new JdbcMetaExplorer(con);
            List tables = jexp.getTables("TABLE");
            generate(tables);
        } catch (SQLException e) {
            log__.error(e);
            throw new GenerateException(e);
        }
    }

    /**
     * <p>XDBiɑΉCreateTableFileGeneratorԂ܂B
     * 擾łȂꍇClassNotFoundExceptionX[܂
     * @param product i
     * @param tbl e[uIuWFNg
     * @return XDBiɑΉCreateTableFileGenerator
     * @exception ClassNotFoundException NXȂꍇ
     */
    public static AbstractSqlGenerator getSqlGenerator(String product, Table tbl)
        throws ClassNotFoundException {
        return SqlGeneratorFactory.getSqlGenerator(product, tbl);
    }
}
